import { onDestroy, unstate } from 'svelte';
import { MutationObserver, notifyManager } from '@tanstack/query-core';
import { useQueryClient } from './useQueryClient';
export function createMutation(options, queryClient) {
    const client = useQueryClient(queryClient);
    const observer = $derived(new MutationObserver(client, options));
    const mutate = $state((variables, mutateOptions) => {
        observer.mutate(variables, mutateOptions).catch(noop);
    });
    $effect.pre(() => {
        observer.setOptions(options);
    });
    let result = $state(observer.getCurrentResult());
    const un = observer.subscribe((val) => {
        notifyManager.batchCalls(() => {
            console.log('result updated', val);
            Object.assign(result, val);
            // result = val
        })();
    });
    onDestroy(() => {
        un();
    });
    /*
    let data = $derived({
      ...result,
      mutate,
      mutateAsync: result.mutate,
    }) */
    /*  $effect(() => {
      Object.assign(data, {
        ...result,
        mutate,
        mutateAsync: result.mutate,
      })
    }) */
    return new Proxy(result, {
        get: (target, prop) => {
            const r = {
                ...result,
                mutate,
                mutateAsync: result.mutate,
            };
            if (prop == 'value')
                return r;
            return r[prop];
        },
    });
}
// eslint-disable-next-line @typescript-eslint/no-empty-function
function noop() { }
